--- vendor/plugins/ActiveRecordExtensions/lib/active_record_extensions.rb.orig	2006-02-11 23:11:47.502206369 +0900
+++ vendor/plugins/ActiveRecordExtensions/lib/active_record_extensions.rb	2006-02-11 23:22:55.838666408 +0900
@@ -27,6 +27,7 @@
     class AbstractAdapter
       protected
         def symbolize_foreign_key_constraint_action(constraint_action)
+          return nil if constraint_action.nil?
           constraint_action.downcase.gsub(/\s/, '_').to_sym
         end
     end
@@ -43,7 +44,7 @@
         result.each do |row| 
           # pg_catalog.pg_get_constraintdef returns a string like this:
           # FOREIGN KEY (user_id) REFERENCES users(id) ON UPDATE CASCADE ON DELETE CASCADE
-          if row[1] =~ /FOREIGN KEY \((.+)\) REFERENCES (.+)\((.+)\) ON UPDATE (\w+) ON DELETE (\w+)/
+          if row[1] =~ /FOREIGN KEY \((.+)\) REFERENCES (.+)\((.+)\)(?: ON UPDATE (\w+))?(?: ON DELETE (\w+))?/
             keys << ForeignKeyConstraintDefinition.new(row[0],
                                                        Regexp.last_match(1),
                                                        Regexp.last_match(2),
@@ -128,6 +129,9 @@
       
       def add_foreign_key_constraint(table_name, foreign_key, reference_table, reference_column, options = {})
         constraint_name = options[:name] || "#{table_name}_ibfk_#{foreign_key}"
+        if /\A\$/.match(constraint_name)
+          constraint_name = '"' + constraint_name + '"'
+        end
         
         sql = "ALTER TABLE #{table_name} ADD CONSTRAINT #{constraint_name} FOREIGN KEY (#{foreign_key}) REFERENCES #{reference_table} (#{reference_column})"
     
